<?php
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

//new for Joomla 3.0
if(!defined('DS')){
define('DS',DIRECTORY_SEPARATOR);
}

class  plgJ2StoreInvoicemanager extends JPlugin
{

    function __construct(& $subject, $config)
    {
        $lang = JFactory::getLanguage();
        $lang->load('com_invoices', JPATH_SITE);

        parent::__construct($subject, $config);

    }

    function onJ2StoreAfterPayment($order_obj)
    {
      if(in_array($order_obj->order_state_id, $this->params->get('activate_on', array('1')))){

        $this->createInvoice($order_obj);

      }
    }

    function onJ2StoreAfterOrderstatusUpdate($order_obj, $status_id)
    {
      if(in_array($order_obj->order_state_id, $this->params->get('activate_on', array('1')))){

        $this->createInvoice($order_obj);

      }
    }

    function createInvoice($data){

        require_once(JPATH_SITE.DS.'components'.DS.'com_invoices'.DS.'helpers'.DS.'helpers.php');

        $j2items = $data->getItems();
        $itemKeys = array_keys($j2items);

        $component = "com_j2store" ;

        $db = JFactory::getDBO();

        $is_new = false;
        $must_update = false ;
        $invoice_id = 0 ;

        //get the actual Order ID
        // $query = " SELECT j2store_order_id FROM #__j2store_orders WHERE order_id = '".$j2items[$itemKeys[0]]->order_id . "' ";
        // $db->setQuery($query);
        // $order_id = $db->loadResult();

        $order_id = $data->j2store_order_id;

        //we check if this particular order had already been tracked
        $query = " SELECT id FROM #__invoices_invoices WHERE external_type = '".$component."' AND external_id = ".$order_id;
        $db->setQuery($query);
        $exists = $db->loadResult();

        if(!$exists){
            $is_new = true ;
        }
        else{
            $must_update = true ;
            $invoice_id = $exists;
        }

        if($is_new || $must_update){

            $params = JComponentHelper::getParams( 'com_invoices' );

            $query = ' SELECT i.real_invoice_num FROM #__invoices_invoices as i WHERE i.type = 1 '.
                ' ORDER BY i.id DESC ';
            $db->setQuery( $query );
            $real_invoice_num = $db->loadResult() + 1;
            $invoice_num = InvoicesHelper::getInvoiceNum($real_invoice_num) ;

            $taxes = array();

            $user = JFactory::getUser($data->created_by);

            $query = ' SELECT * FROM #__j2store_orderinfos WHERE order_id = '.$data->order_id;
            $db->setQuery($query);
            $orderinfos = $db->loadObject();

            $invoice_data = array(
                "id" => $invoice_id,
                "to_name" => $orderinfos->billing_first_name . ' ' . $orderinfos->billing_middle_name . ' ' . $orderinfos->billing_last_name ,
                "to_company" => $orderinfos->billing_company,
                "to_address" => $orderinfos->billing_address_1 . ' '. $orderinfos->billing_address_2,
                "to_email" => $user->email,
                "to_zipcode" => $orderinfos->billing_zip,
                "to_city" => $orderinfos->billing_city,
                "to_state" => $orderinfos->billing_zone_name,
                "to_country" => $orderinfos->billing_country_name,
                "to_phone" => $orderinfos->billing_phone_1,
                "to_vatid" => $orderinfos->billing_tax_number,
                "vincular_cliente_checkbox" => 2,
                "from_name" => $params->get('from_name'),
                "from_address" => $params->get('from_address'),
                "from_num" => $params->get('from_num'),
                "from_url" => $params->get('from_url'),
                "from_email" => $params->get('from_email'),
                "from_phone" => $params->get('from_phone'),
                "invoice_num" => $invoice_num,
                "real_invoice_num" => $real_invoice_num,
                "invoice_date" => $data->created_on,
                "template_id" => $params->get('invoice_template'),
                "currency_before" => $params->get('currency_before'),
                "currency_after" => $params->get('currency_after'),
                "publish" => $this->params->get('activation'),
                "start_publish" => "",
                "end_publish" => "",
                "joomla_user_id" => $user->id,
                "taxes" => $taxes,
                "status" => '',
                "external_type" => $component,
                "external_id" => $order_id,
                "external_ref" => $data->order_id,
                "is_recurrent" => 0,
                "automatic_payment" => 0
            ) ;

            $items = array();

            foreach ($itemKeys as $key) {

              $product_id = 0 ;

              if($must_update){
                $query = " SELECT id FROM #__invoices_items WHERE invoice_id = '".$invoice_id."' AND external_type = '".$component."' AND product_id = ".$j2items[$key]->cartitem_id;
                $db->setQuery($query);
                $product_id = $db->loadResult();
              }

              // print_r($j2items[$key]);die;

              $tax = $j2items[$key]->orderitem_tax * 100 / ($j2items[$key]->orderitem_finalprice_without_tax) ;
              $items[] = array(
                  "id" => $product_id,
                  "sku" => $j2items[$key]->orderitem_sku,
                  "name" => $j2items[$key]->orderitem_name,
                  "desc" => "",
                  "value" => $j2items[$key]->orderitem_finalprice_without_tax / $j2items[$key]->orderitem_quantity,
                  "amount" => $j2items[$key]->orderitem_quantity,
                  "tax" => $tax,
                  "external_type" => $component,
                  "product_id" => $j2items[$key]->cartitem_id,
              );

            }

            $payments = array();

            InvoicesHelper::create_invoice($invoice_data, $items, $payments);

        }

    }

}
